********************************************
* Analysis of Okun's Law
********************************************

********************************************
* Read in data
********************************************

set more off
clear
clear matrix
use "$main\data\usa_q_transformed_updated.dta"
cd "$main\outputs"
sort quarter
tsset quarter
sort quarter
save temp, replace

********************************************
* Estimate fitted
********************************************

gen y = u_star1600
gen ystar = u_hpf1600
gen x = y_star1600
gen L1x = x[_n-1]
gen L2x = x[_n-2]

regress y x L1x L2x, noconstant
predict yhat
predict yhat_se, stdp

* Actual vs. fitted U
preserve
* Variables
gen urhat = ystar + yhat
* Sample
drop if quarter>=tq(2014q1)
* Chart
twoway (line ur urhat quarter, ///
lcolor(black black) lpattern(solid dash) ///
legend(label(1 "actual") label(2 "fitted") ring(0) position(12) region(lstyle(none)) ) ///
ylabel(0(2)12) xlabel(, format(%tqCY)) xtitle("")scheme(s2mono)saving(Figure_2,replace) ) 

sum ur urhat
*Numbersa in page 15
clist quarter ur urhat if quarter==tq(2006q4) | quarter==tq(2009q4) , noobs
restore

