********************************************
* Analysis of Okun's Law
* Contacts: Daniel Leigh and Jair Rodriguez
********************************************

********************************************
* Read in data
********************************************


clear

use "$main\data\usa_q_transformed_updated"
cd "$main\outputs"

*gen time = quarterly(quarter, "YQ")
*format time %tq
*drop quarter
*rename time quarter
sort quarter
tsset quarter
sort quarter
save temp, replace
/*
*
*/
gen lgdp_star16000 = logy - logy_hpf16000  
gen lgdp_star1600  = logy - logy_hpf1600

matrix table2u = J(5,18,.)
matrix table2l = J(4,6,.)
********************************************
* Regressions
********************************************
cap erase Table2.xls
cap erase Table2.txt
local i = 0
local j = 0
local y = 4
foreach x in 1600 16000{
local j = 1+ `j'
local i = `i'+1

*** Sample
keep if quarter <= tq(2013q4)

*** Levels: HPF = 1,600
		regress u_star`x' lgdp_star`x', noconstant
                local n = e(N)
				matrix table2l[1,`j']=e(N)
                local l = `n'^(1/4)
                local l = round(`l')
				matrix table2l[2,`j'] = e(r2_a)
				matrix table2l[3,`j'] = e(rmse)
                dwstat
				matrix table2l[4,`j'] = r(dw)
				
	newey  u_star`x' lgdp_star`x', noconstant lag(`l')
	matrix  table2u[1, `i']= _b[lgdp_star`x']
	local i = `i'+1
	matrix  table2u[1, `i']= _se[lgdp_star`x']
	test _b[lgdp_star`x']=0
	local i = `i'+1
	matrix  table2u[1, `i']= r(p)
	* Store results in outreg table	
	

*With Lags				
				local j = `j'+1
				
		regress u_star`x' lgdp_star`x' l1.lgdp_star`x' l2.lgdp_star`x', noconstant
                local n = e(N)
				matrix table2l[1,`j']=e(N)
                local l = `n'^(1/4)
                local l = round(`l')
				matrix table2l[2,`j'] = e(r2_a)
				matrix table2l[3,`j'] = e(rmse)
                dwstat
				matrix table2l[4,`j'] = r(dw)
				local i = `i'+1
		newey  u_star`x' lgdp_star`x' l1.lgdp_star`x' l2.lgdp_star`x', noconstant lag(`l')
				matrix  table2u[1, `i']= _b[lgdp_star`x']
				local i = `i'+1
				matrix  table2u[1, `i']= _se[lgdp_star`x']
				test _b[lgdp_star`x']=0
				local i = `i'+1
				matrix  table2u[1, `i']= r(p)
				
				*l1	
				matrix  table2u[2, `y']= _b[l1.lgdp_star`x']
				matrix  table2u[2, `y'+1]= _se[l1.lgdp_star`x']
				test _b[l1.lgdp_star`x']=0
				matrix  table2u[2, `y'+2]= r(p)
				*l2	
				matrix  table2u[3, `y']= _b[l2.lgdp_star`x']
				matrix  table2u[3, `y'+1]= _se[l2.lgdp_star`x']
				test _b[l2.lgdp_star`x']=0
				matrix  table2u[3, `y'+2]= r(p)
				*b0+b1+b2
				
				lincom _b[lgdp_star`x' ] + _b[l1.lgdp_star`x'] + _b[l2.lgdp_star`x']
				matrix  table2u[4, `y']== r(estimate)
				matrix  table2u[4, `y'+1] =round( r(se),0.001)
				test _b[lgdp_star`x'] + _b[l1.lgdp_star`x'] + _b[l2.lgdp_star`x'] = 0
				matrix  table2u[4, `y'+2] = r(p)
	local y = `y'+6
	}
	
	

*** First differences
           regress ur_chg y_chg
				local n = e(N)
				matrix table2l[1,5]=e(N)
                local l = `n'^(1/4)
                local l = round(`l')
				matrix table2l[2,5] = e(r2_a)
				matrix table2l[3,5] = e(rmse)
                dwstat
				matrix table2l[4,5] = r(dw)
				
          newey  ur_chg y_chg, lag(`l')
	local i =13
	matrix  table2u[1, `i']= _b[y_chg]
	matrix  table2u[1, `i'+1]= _se[y_chg]
	test _b[y_chg]=0
	matrix  table2u[1, `i'+2]= r(p)
	
	matrix  table2u[5, `i']= _b[_cons]
	matrix  table2u[5, `i'+1]= _se[_cons]
	test _b[_cons]=0
	matrix  table2u[5, `i'+2]= r(p)

		
****

	regress ur_chg y_chg l1.y_chg l2.y_chg
				local n = e(N)
				matrix table2l[1,6]=e(N)
                local l = `n'^(1/4)
                local l = round(`l')
				matrix table2l[2,6] = e(r2_a)
				matrix table2l[3,6] = e(rmse)
                dwstat
				matrix table2l[4,6] = r(dw)
				
	newey  ur_chg y_chg l1.y_chg l2.y_chg, lag(`l')
				local i =16
				*L0
				matrix  table2u[1, `i']= _b[y_chg]
				matrix  table2u[1, `i'+1]= _se[y_chg]
				test _b[y_chg]=0
				matrix  table2u[1, `i'+2]= r(p)
				
				*l1	
				matrix  table2u[2, `i']= _b[l1.y_chg]
				matrix  table2u[2, `i'+1]= _se[l1.y_chg]
				test _b[l1.y_chg]=0
				matrix  table2u[2, `i'+2]= r(p)
				*l2	
				matrix  table2u[3, `i']= _b[l2.y_chg]
				matrix  table2u[3, `i'+1]= _se[l2.y_chg]
				test _b[l2.y_chg]=0
				matrix  table2u[3, `i'+2]= r(p)
				*b0+b1+b2
				
				lincom _b[y_chg ] + _b[l1.y_chg] + _b[l2.y_chg]
				matrix  table2u[4, `i']== r(estimate)
				matrix  table2u[4, `i'+1] =round( r(se),0.001)
				test _b[y_chg] + _b[l1.y_chg] + _b[l2.y_chg] = 0
				matrix  table2u[4, `i'+2] = r(p)
				
				*alpha
				matrix  table2u[5, `i']= _b[_cons]
				matrix  table2u[5, `i']= _b[_cons]
				matrix  table2u[5, `i'+1]= _se[_cons]
				test _b[_cons]=0
				matrix  table2u[5, `i'+2]= r(p)



mat coln table2l = "hp_1600" "hp_1600_L" "hp_16000" "hp_16000_L" "Differences" "Differences_L"
mat coln table2u = "C1_b"	"C1_se"	"C1_pv"	"C2_b"	"C2_se"	"C2_pv"	"C3_b"	"C3_se"	"C3_pv"	"C4_b"	"C4_se"	"C4_pv"	"C5_b"	"C5_se"	"C5_pv"	"C6_b"	"C6_se"	"C6_pv"
matrix rowname table2u = "R1_b0" "R2_b1" "R3_b2" "R4_b0+b1+b2" "R5_alpha"
matrix rownames table2l  = "Observations" "Adjusted_R2" "RMSE" "Durbin_Watson"

clear
svmat2 table2l, names(col)  rnames(title)
tostring hp_1600 hp_1600_L hp_16000 hp_16000_L Differences Differences_L, replace force format (%4.3f)
order title
tempfile stats
save `stats'
clear
svmat2 table2u , names(col)  rnames(title)
forvalues x=1/6{

tostring C`x'_b C`x'_se , replace force format (%4.3f)
replace C`x'_b= C`x'_b + "***" if C`x'_pv<0.01
replace C`x'_b= C`x'_b + "**" if C`x'_pv<0.05 & C`x'_pv>=0.01
replace C`x'_b= C`x'_b + "*" if C`x'_pv<0.1 & C`x'_pv>=0.05
replace C`x'_se = "("+C`x'_se+")" if C`x'_se!="."
drop C`x'_pv
}
reshape long C1 C2 C3 C4 C5 C6, i(title) j(c) string
local i =1
foreach x in "hp_1600" "hp_1600_L" "hp_16000" "hp_16000_L" "Differences" "Differences_L"{ 
rename C`i' `x'
local i = `i'+1
} 
append using `stats' ,force
drop c

export excel Table_2, first(var) replace







